﻿namespace UltragridAddRow
{
    using System;
    using System.Collections.Generic;
    using System.Data;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public const int GridRows = 10;
        private Random random = new Random();

        public Form1()
        {
            this.InitializeComponent();
            this.ultraGrid1.DataSource = this.GetData(GridRows);
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowAddNew = AllowAddNew.TemplateOnBottom;
        }

        private DataSet GetData(int rows)
        {
            DataSet ds = new DataSet();

            DataTable dt = ds.Tables.Add();
            dt.Columns.Add("Id", typeof(int)).AllowDBNull = false;
            dt.Columns.Add("Name", typeof(string)).AllowDBNull = false;
            dt.Columns.Add("Amount", typeof(int)).AllowDBNull = false;
            dt.Columns.Add("Date", typeof(DateTime)).AllowDBNull = false;

            for (int row = 0; row < rows; row++)
            {
                int id = row;
                string name = string.Format("Element #{0}", row);
                int amount = this.random.Next(0, 100);
                DateTime theDate = DateTime.Now.AddDays(this.random.Next(-100, 100));

                dt.Rows.Add(new object[] { id, name, amount, theDate });
            }

            return ds;
        }

        private void ultraGrid1_BeforeCellDeactivate(object sender, System.ComponentModel.CancelEventArgs e)
        {
            e.Cancel = this.InvalidCellValue(((UltraGrid)sender).ActiveCell);
            if (e.Cancel)
            {
                ((UltraGrid)sender).PerformAction(UltraGridAction.EnterEditMode);
            }
        }

        private bool InvalidCellValue(UltraGridCell ultraGridCell)
        {
            bool invalidCellValue = false;
            switch (ultraGridCell.Column.Key)
            {
                default:
                    invalidCellValue = string.IsNullOrEmpty(ultraGridCell.Value.ToString());
                    break;
            }

            return invalidCellValue;
        }
    }
}
